package actions;

import java.util.ArrayList;

import classifierLibrary.StandardSituation;
import enums.SellingType;
import animals.Animal;

public interface Selling 
{
	
	/**
	 * Individual selling - no norm
	 * @param allAnimals
	 * @return animals to be sold
	 */
	public ArrayList<Animal> sellIndividual(ArrayList<Animal> allAnimals);
	/**
	 * Selling according to norm (and labour constraint) - first bulls over cows, second older over younger animals
	 * @param allAnimals
	 * @param nrToSell
	 * @return animals to be sold
	 */
	public ArrayList<Animal> sellNrOfAnimals(ArrayList<Animal> allAnimals, double nrToSell);
	/**
	 * stores the revenue generated from the current sale of animals
	 * @param animalsToSell
	 * @param allAnimals
	 */
	public void storeAgriRevFromThisSale(ArrayList<Animal> animalsToSell, ArrayList<Animal>allAnimals);
	/**
	 * stores investment costs for new entries
	 */
	public void storeInvestmentCosts();
	/**
	 * resets all monetary values stored in caes of exits
	 */
	public void resetMyAgriRevs();
	/**
	 * 
	 * @return
	 */
	public double avrMprofit();
	/**
	 * logical constrain - HH cannot have more than 130 animals cause of labour constrains
	 * @param allAnimals
	 * @return
	 */
	public ArrayList<Animal> sellMaxLabourSize(ArrayList<Animal> allAnimals);
	/**
	 * returns the current monetary value of animals in the argument
	 * @param aListOfAnimals
	 * @return
	 */
	public double getValueOfAnimals(ArrayList<Animal> aListOfAnimals);
	
	
//scenario methods not used in paper////	
	public ArrayList<Animal> sellIndividual(ArrayList<Animal> allAnimals,SellingType type, double currentMonth);
	public ArrayList<Animal> sellIndividualSimpleRule(ArrayList<Animal> allAnimals, double ageToSell);


}
