package agents;

import java.util.HashMap;

import actions.Selling;
import repast.simphony.context.Context;
import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;
import repast.simphony.random.RandomHelper;
import ses.GlobSpace;
import classifierLibrary.Situation;
import dataClasses.Entry;
import demoZLCS.ZLCS;

/**
 * A non-livestock owning HH
 * @author karma
 *
 */
public class OtherHHImpl extends AbstractHH implements EntryAble
{
	/**
	 * Instatination through abstract super class
	 * @param theContext
	 * @param mySellingDecsion
	 * @param theGlobSpace
	 */
	public OtherHHImpl(Context theContext, Selling mySellingDecsion, GlobSpace theGlobSpace) 
	{
		super(theContext,mySellingDecsion, theGlobSpace);
	}

	@Override
	public boolean isEntry() 
	{
		boolean checker = false;
			
		if(accSavingsMemb*hhSize>=4000)//HH can only buy new cows if savings are sufficient (logic constraint)
		{
			double incMemb = (nonAgriInc/hhSize);
			double logRegrProb = (Entry.entryProb(incMemb, hhSize, age));//logistic regression on the probability to enter
			RandomHelper.createUniform(0, 1);
			double randNr = RandomHelper.getUniform().nextDoubleFromTo(0, 1.0);
			if(randNr<=logRegrProb)
			{
				accSavingsMemb=accSavingsMemb-(4000/hhSize);
				checker= true;	
			}	
		}
		return checker;	
	}

	@Override
	public ProducerHH entry() 
	{
		HashMap<java.lang.String, Double> attributes = new HashMap<java.lang.String, Double>();
		ProducerHH aProducer = new ProducerHHImpl(theContext, this.mySellingDecision, this.theGlobSpace);
		
		aProducer.setDefector(defector);		
		attributes.put("realId",new Double (id));
		attributes.put("hhSize",new Double (hhSize));
		attributes.put("age",new Double (age));
		attributes.put("nonAgriInc",new Double (nonAgriInc));
		attributes.put("agriInc",new Double (0));
		attributes.put("monthSavingsMemb",new Double (monthSavingsMemb));
		attributes.put("accSavingsMemb",new Double (accSavingsMemb));
		attributes.put("coop",new Double (coop));
		attributes.put("iniCoop",new Double (iniCoop));
		attributes.put("expCoop",new Double (expCoop));
		attributes.put("recipr",new Double (recipr));
		attributes.put("expRecpr",new Double (expRecpr));
		attributes.put("waterInKraal",new Double (water));
		attributes.put("incrBirth",new Double (incrBirth));
		
		aProducer.iniWithOtherHHData(attributes);
		aProducer.storeInvestmentCosts();
		aProducer.addCow();
		aProducer.setCooperator(cooperated);
		
		theContext.remove(this);
	
		return aProducer;
	}
	
	public void iniWithFileData(HashMap<String, Double> attributes)
	{
		super.iniWithFileData(attributes);
		double savings = attributes.get("percSavings");
		monthSavingsMemb=savings;
	}

	
	
//////////////method for scenario not part of the current paper///////////////////////////	
	private void iniCalvingParameters()
	{
		RandomHelper.createUniform(0,1);
		double  rndNr = RandomHelper.getUniform().nextDoubleFromTo(0, 1);
		if(rndNr<0.363)
		{
			water =0;
		}
		else
		{
			water =1;
			rndNr = RandomHelper.getUniform().nextDoubleFromTo(0, 1);
			if(rndNr<0.922)
			{
				incrBirth=0;
			}
			else
			{
				incrBirth=1;
			}
		}
	}
}
