package agents;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;

import classifierLibrary.StandardSituation;
import animals.Animal;

public interface ProducerHH extends SimpleHH
{
	/**
	 * increases monthly live-weight gain of individual herds
	 * @param lwg
	 */
	public void informLwg(double lwg);
	public Collection<? extends Animal> getAnimals();
	/**
	 * ages the herd and transforms calves into bulls or cows
	 */
	public void ageYourAnimals();
	/**
	 * calculates the new population of heifers (>1 year) in every year based on the branding rate and cows of last year
	 * @param yearlyLwg
	 */
	public void birthYourAnimalsBrand(double yearlyLwg);
	/**
	 * causes the death of animals based on yearly % mortality
	 * @param yearlyLwg
	 */
	public void dieYourAnimals(double yearlyLwg);
	public void addCow();
	public double getHerdSize();
	/**
	 * checker for exiting producers
	 * @return
	 */
	public boolean isExit();
	/**
	 * exit method. Creates a new non-livestock owning HH and removes the current one
	 * @return
	 */
	public EntryAble exit();	
	/**
	 * updates individual cooperativeness 
	 * @param groupRepuation level of norm followers
	 * @param severity degree of norm violations
	 */
	public void updateCooperation(double groupRepuation, double severity);
	/**
	 * Returns individual conditional cooperativeness
	 * @return
	 */
	public double getConditionalCooperation();
	/**
	 * Individual selling of animals (no norm)
	 * @return
	 */
	public  ArrayList<Animal> sellIndividual();
	/**
	 * Selling triggerd by the norm
	 * @return
	 */
	public  ArrayList<Animal>  sellNorm(); 
	/**
	 * returns the monetary value of the herd
	 * @return
	 */
	public double getValueOfHerd();
	/**
	 * stores investment costs for new entries into livestock production for calculating profits
	 */
	public void storeInvestmentCosts();
	/**
	 * returns the average monthly agricultural profit
	 * @return
	 */
	public double getAgriRev();

	
}
