package agents;

import java.util.HashMap;

/**
 * interface implemented by an abstract HH class with methods common to both agent types
 * @author karma
 *
 */
public interface SimpleHH 
{
	/**
	 * computes monthly savings of HH
	 */
	public void hhBalanceSimple();
	public void hhBalanceTypes();
	/**
	 * initializes all HH with data from input files where they are not specific to the HH type
	 */
	public void iniWithFileData(HashMap<String, Double> attributes);
	/**
	 * used to re-instatinate entering. Data is taken over from exiting HH stored  in a hashmap
	 */
	public void iniWithOtherHHData(HashMap<String, Double> attributes);
	/**
	 * checker for norm following
	 * @return
	 */
	public boolean isCooperator();
	/**
	 * sets HH to norm follower
	 * @param isCooperator
	 */
	public void setCooperator(boolean isCooperator);
	/**
	 * random initialization for last norm following value at start of simulation
	 */
	public void iniCooperator();
	/**
	 * resets accumulated savings
	 */
	public void resetAccSavings();
	
/////////////used for scenario not part the current publication/////////////
	/**
	 * sets agent to be a permanent defector
	 * @return
	 */
	public void setDefector(boolean isDefector);
	/** 
	 * returns true if agent is a permanent defector
	 * @return
	 */
	public boolean isDefector(); 
}
