package animals;

import enums.CalvingInterval;
import repast.simphony.context.Context;

/**
 * a cow
 * @author karma
 *
 */
public class Cow extends Animal
{
	double nrOfCalves=0;
	double calvingInterval;
	
	public Cow(double iniWeight, Context theContext)
	{
		super(theContext);
		bodyWeight=iniWeight;
	}
	
	/**
	 * Aging is overwritten to account for pregnancy
	 */
	public void aging()
	{
		calvingInterval--;
		age+=(1.0/12.0);
	}
	
	/**
	 * increases the number of calves born by this cow
	 */
	public void incNrOfCalves()
	{
		nrOfCalves++;
	}
	
	/**
	 * returns the number of calves born by this cow
	 * @return
	 */
	public double getNrOfCalves()
	{
		return nrOfCalves;
	}
	
//////////scenario method used for monthly births not used in the current paper/////////////////////////
	
	public void setCalvingInterval(CalvingInterval interval)
	{
		if(interval==CalvingInterval.twelveMonth)
		{
			calvingInterval=12;
		}
		else if(interval==CalvingInterval.eighteenMonths)
		{
			calvingInterval=18;
		}
		else if(interval==CalvingInterval.twentyFourMonths)
		{
		    calvingInterval=24;
		}
		else
			calvingInterval=18;
	}
	
	public boolean isBirth()
	{
		if(calvingInterval<=0)
			return true;
		else
			return false;
	}
}
