package ses;

import java.util.Calendar;

import dataClasses.LinkContainer;

public class BiomassModel extends BiomassModelS implements BiomassSimulator {
	
	//conversion rates
	private static int gm2_kgha = 10;
	private static double daysinmonth = 365/12;

	public BiomassModel(int compCode, int campNr) {
		//super(new LinkContainer().getSolLinkComp());
		super("D:/WORKSPACES/Revision/LinrangeU/simulation/conf/slim/LinrangeSlim2.sol.xml");
	}
	
	@Override
	public void initRun() 
	{
		super.initRun();
	}
	
	@Override
	public int stepMonth(int currentMonth,  double offtake, double gfd) 
	{
		super.stepTime(Calendar.MONTH, 1, (offtake/daysinmonth)/gm2_kgha, gfd);
		return currentMonth;
	}
	
	@Override
	public void finishRun() 
	{	
		super.finishRun();
	}
	
	@Override
	public void finish() 
	{
		super.finish();
	}
		
	/**
	 * Total standing crop is Green Standing Crop + Senescent Standing Crop
	 */
	@Override
	public double getTSC() 
	{
		double total=((getW_sh()+getW_sen()) * gm2_kgha);
		return total;
	}

	@Override
	public double getGSC() 
	{
		double green=(getW_sh() * gm2_kgha);
		return green;
	}

	@Override
	public double getGGrowth() 
	{
		return GrGrowthMonth() * gm2_kgha;
	}
	
	@Override
	public double getActualGFD() 
	{
		return actualGFD();
	}
	
	@Override
	public double getActualOfftake() 
	{
		return actOfftake() * gm2_kgha;
	}

	@Override
	public double getActualIntMult() 
	{
		return actualIntMult();
	}
	
	public double getWUE_Pr_A() 
	{
		return WUE_Pr_A()*gm2_kgha;
	}
	
	public double getWUE_Pr_T() 
	{
		return WUE_Pr_T()*gm2_kgha;
	}
	
	public double getWUE_ET_A() 
	{
		return WUE_ET_A()*gm2_kgha;
	}
	
	public double getWUE_ET_T() 
	{
		return WUE_ET_T()*gm2_kgha;
	}
	
	public double getBasalArea()
	{
		return getBA();
	}
	
	public double getRain()
	{
		return getSumPrec();
	}
}
