package ses;

/**
 * utility class for reading input data
 */
import java.util.HashMap;

public final class InputMap<V> extends HashMap <String, V>
{

	@Override
	public V put (final String key, final V value)
	{
		return super.put(normalizeKey(key), value);		
	}
	
	public V put (final Integer key, final V value)
	{
		return super.put(key.toString(), value);
	}
	
	@Override
	public V get(final Object key)
	{
		return super.get(normalizeKey((String) key));
	}
		
	public V getFromInt(final Object key)
	{
		return super.get(key);
	}

	private String normalizeKey(final String key)
	{
		if (key==null)
			return null;
		return key.toUpperCase().trim();
	}
}
