package ses;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public  class  ReaderHelper 
{

	/**
	 * reads and csv file containing all participant data. Csv file can have and nr of rows and columns
	 * @return a double [][] with participant data in matrix form
	 * @throws IOException
	 */
	public static double [][] readAllData (String fileName) throws IOException
	{
		//Read the file
		BufferedReader CSVFile =  new BufferedReader(new FileReader(getFullPathName(fileName)));
		//Read the first line
		String dataRow = CSVFile.readLine();
		
		//initilize local variables
		int rows =0;
		int helper = 0;
		int cols =0;
		
		//first calculate the amount of rows and colums of the file
		while (dataRow != null)
		  {
			String[] dataArray = dataRow.split(";");//get array of cells of one row in the file
			   for (String item:dataArray) 
				   { 			   	  
				   	  helper++;//count the cells of the line
				   }
			   rows++;//count the rows 
			   dataRow = CSVFile.readLine();//read in the next line
		  }
		cols=helper/rows;//colums are all cells (with values) devided by the number of rows
		int agents = rows-1;//first row is a string in the file which means it is not an agent
		
//System.out.println("Agents : "+agents+" Attributes : "+cols);
		
		//read the file again to start from the top with readLine()
		CSVFile =  new BufferedReader(new FileReader(getFullPathName(fileName)));
		dataRow = CSVFile.readLine();//first line are headers
		dataRow = CSVFile.readLine();//second line is beginning of data
		
		double [][] data = new double [rows][cols];// first row is for meta data in the new array matrix
		data[0][0]=agents;// Number of participants
		data[0][1]=cols;// Number of attributes
		int i=1;// not zero because is second line (first line is for meta data)s
		int j=0;
		//get the data in 
		while (dataRow != null)
		  {	
			   String[] dataArray = dataRow.split(";");
			   for (String item:dataArray) 
				   { 
						   data[i][j]=Double.parseDouble(item);
						   j++;
				   }
			   j=0;
			   i++;
			   dataRow = CSVFile.readLine();
		  }
		CSVFile.close();
		return data;
	}
	
	/**
	 * extracts a sinlge participant from a data structure with all participants
	 * @param partNr running participant id
	 * @param attributeNr nr of attributes
	 * @param inputMatrix double [][] with all participants in matrix form
	 * @return a single double [] with data on one participant
	 */
	public static double [] extractSingleParticipantData (int partNr, int attributeNr, double [][] inputMatrix)
	{
		double [] specParData = new double[attributeNr];
		for (int z=0; z<attributeNr;z++)
		{
			specParData[z] = inputMatrix[partNr][z];
		}
		return specParData;
	}
	
	/**
	 * 
	 * @param data an array for the data of one Participant
	 * @param nrAtt the number of attributes per participant
	 * @return a Hashmap with attribute names for the data of the participant
	 * @throws IOException
	 */
	public static HashMap<String, Double> createMap (double [] data, int nrAtt, String theFileName) throws IOException
	{
		BufferedReader CSVFile =  new BufferedReader(new FileReader(getFullPathName(theFileName)));
		String metaData = CSVFile.readLine(); // Read first line with string meta data
		InputMap<Double> partDataMap = new InputMap<Double>();
		//HashMap<String, Double> partDataMap = new HashMap<String, Double>();
		
		if (metaData != null)
		  {
			String[] headers = metaData.split(";");
			for (int i =0; i<nrAtt;i++)
			{
				partDataMap.put(headers[i],new Double (data[i]));
			}		   
		  }
		return partDataMap;
	}
	
	public static ArrayList<Double> getRates(String fileName) throws IOException
	{
		ArrayList<Double> rates = new ArrayList();
		BufferedReader CSVFile =  new BufferedReader(new FileReader(getFullPathName(fileName)));
		String dataRow = CSVFile.readLine();
		dataRow = CSVFile.readLine();//first line is header
		while (dataRow != null)
		  {	
			   String[] dataArray = dataRow.split(";");
			   for (String item:dataArray) 
				   { 
				   		rates.add(Double.parseDouble(item));
				   }
			   dataRow = CSVFile.readLine();
		  }
		CSVFile.close();
		return rates;
	}
	
	private static String getFullPathName(String fileName)
	{
		Parameters params = RunEnvironment.getInstance().getParameters();
		String fullFileName = (String)params.getValue("dir_name_InputData") + fileName;
		return fullFileName+".csv";
	}
}
